/****************/
/* vaihtaja.cpp */
/****************************************************************************
    PROGRAM: vaihtaja.cpp
    PURPOSE: Vaihtaa rahaa ja matkoja
             Ohjelmalla esitelln omatekoisten dialog boxien kytt.
             Pikkuna tekee vain menun, jolla voidaan valita mik
             dialog box tulee aktiiviseksi

             Skaalausvaihtajan oletusikkunana on luonnosta mitattu
             matka.  Painamalla ENTER (IDOK) pstn aina thn ikkunaan.
             Kun ikkunaan tullaan, valitaan koko ikkunassa oleva teksti, jotta
             uuden syttminen olisi helpompaa.

             Ikkunoiden toimintajrjestys on valittu Resource Workshopissa
             toiminnolla Options - Set order.

             Ikkunat ovat kytettviss yhtaikaa jos ne on luotu Modeless.
             Modeless-dialogien on kyttn omat aliohjelmat,
             jotka tallettavat kaikki kyttn otetut modeless dialogit.
             Modeless tai Modal dialogi valitaan kutsun perusteella
               Create() tai
               Execute()
             Itse dialogit voivat olla samoja.

    PROJECT:
      vaihtaja.cpp
      vaihtaja.rc
      vaihtaja.def  // Win 3.11
      scaling.cpp   = scaling-dialogin ksittely.

    TEHTVI:
             1)  Kokeile vaihdella dialogien kynnistykess TRUE/FALSE
                   (modeless vai ei)

             2)  Tydenn rahanvaihto toiminto valmiiksi.

             3)  Kokeile muuttaa dialogin oletusjrjetyst (RWSHOP!)

             4)  Lis ohjelmaan lmptilojen muunnos.

             5)  Muuta ohjelmaa siten, ett tunnetut muunnokset
                 luetaan dialogin kynnistyess tiedostosta .\SCALING.INI

    Editor:  Vesa Lappalainen 26.10.1992 & 26.8.1994 & 10.11.1996
             6.11.1999 muutettu MFC-versioksi
****************************************************************************/
#include <afxwin.h>
#include "scaling.h"
#include "vaihtaja.rh"

//------------------------------------------------------------------------------
class CMainWindow : public CFrameWnd {
public:
  CMainWindow()
  {
    Create(NULL,"Vaihtaja");
    LoadAccelTable(MAKEINTRESOURCE(IDA_PIKA));
    CMenu menu;
    menu.LoadMenu(IDM_PAAMENU);
    SetMenu(&menu);
    menu.Detach();
    MoveWindow(20,20,400,400,FALSE);
//    SetBkColor(::GetWindowDC(*this),0);
//    SetBackgroundColor
  }
  void OnPaint() {
    CPaintDC hdc(this);
    hdc.TextOut(10,10,"Valitse menusta ohjelma!");
  }
  void CmExit()
  {
    DestroyWindow();
  }
  void CmScaling() {
    RunScaling(this,TRUE);
//    RunScaling(this,FALSE);
  }
  void CmChange() {
    CDialog(IDD_CHANGE,this).DoModal();
  }
  void CmAbout() {
    CDialog(IDD_ABOUT,this).DoModal();
  }
  DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
  ON_WM_PAINT()
  ON_COMMAND(IDM_FILE_EXIT, CmExit)
  ON_COMMAND(IDM_APP_SCALING ,CmScaling)
  ON_COMMAND(IDM_APP_MONEY   ,CmChange)
  ON_COMMAND(CM_HELPABOUT, CmAbout)
END_MESSAGE_MAP()

//-----------------------------------------------------------------------------
class CVaihtajaApp : public CWinApp {
public:
  virtual BOOL InitInstance() {
    m_pMainWnd = new CMainWindow();
	  m_pMainWnd->ShowWindow(m_nCmdShow);
	  m_pMainWnd->UpdateWindow();
          m_pMainWnd->SetIcon(LoadIcon(IDI_IKONI),TRUE);

	  return TRUE;
  }
};

CVaihtajaApp VaihtajaApp;
